*! version 1.0.0 July 24, 2006 @ 00:59:06
*! runs a rename, but first checks to see if the variable is used in another variables validation
program define ckrename, rclass
version 9
	local myname "ckrename"
	syntax anything, [what(str)]
	local oldName: word 1 of `anything'
	local newName: word 2 of `anything'
	unab oldName : `oldName', min(1) max(1) name("ckrename:")
	confirm new var `newName'
	local numNames: word count `anything'
	if `numNames'>2 {
		display as error "`myname': too many variable names specified!"
		exit 198
		}
	if `"`what'"'=="" {
		local what "valid"
		}

	unab allVars : *
	local allVars: list allVars - oldname

	foreach self of local allVars {
		foreach which of local what {
			dolikedig `self', evalchar(`which'_check) datachar(`which'_other_vars_needed) accum
			local possible "`r(contents)' `r(visits)'"
			local numNames: list oldName in possible
			if `numNames' {
				local callingVars "`callingVars' `self'"
				}
			}
		}
	
	local callingVars: list uniq callingVars
	local extras: list callingVars - oldName
	if "`extras'"!="" {
		display as error "The following variable(s) make use of `oldName' for characteristic(s) " as input "`what'_check" as error " to keep) functioning:"
		display as result " `extras'"
		display as error "Change the dependencies before renaming!"
		exit 666
		}

	rename `oldName' `newName'
end
